---
driver number: 0x00000
---

# Alarm

## Overview

The alarm driver exposes a wrapping hardware counter to processes. An alarm can
report the current tick value and notify via a callback when the counter reaches
a certain value.

The alarm's frequency is platform-specific, but must be _at least_ 1kHz.

## Command

  * ### Command number: `0`

    **Description**: Does the driver exist?

    **Argument 1**: unused

    **Argument 2**: unused

    **Returns**: The number of concurrent notifications supported per process,
    0 if unbounded, otherwise NODEVICE

  * ### Command number: `1`

    **Description**: Returns the clock frequency of the alarm.

    **Argument 1**: unused

    **Argument 2**: unused

    **Returns**: The frequency in Hertz.

  * ### Command number: `2`

    **Description**: Read the current counter tick value.

    **Argument 1**: unused

    **Argument 2**: unused

    **Returns**: The counter value in ticks.

  * ### Command number: `3`

    **Description**: Stop an outstanding alarm notification.

    **Argument 1**: Alarm notification identifer as returned from command 4.

    **Argument 2**: unused

    **Returns**: INVAL if the notification identifier is invalid, ALREADY if
    the notification is already disabled, or Ok(()).

  * ### Command number: `5`

    **Description**: Set an alarm notification for a counter value relative to the current value.
    Notification invokes the callback set with subscribe.

    **Argument 1**: The relative counter tick value to notify.

    **Argument 2**: unused

    **Returns**: Tick value when the callback will be called.

  * ### Command number: `6`

    **Description**: Set an alarm notification for an absolute counter value.
    Notification invokes the callback set with subscribe.

    **Argument 1**: The reference point tick value.

    **Argument 2**: Absolute tick value. Callback will be issued
    when it matches current tick value.

    **Returns**: Tick value when the callback will be called.

## Subscribe

  * ### Subscribe number: `0`

    **Description**: Subscribe to alarm notifications.

    **Callback signature**: The callback recieves two arguments: the counter
    tick value when the alarm notification expired and the reference
    tick with which it was registered. The value of the remaining argument is
    undefined.

    **Returns**: Ok(()) if the subscribe was successful or NOMEM if the
    driver failed to allocate memory for the transaction.

